/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
/***************************************************************************
 * nm-ipsec-l2tp.h : GNOME UI dialogs for configuring l2tp VPN connections
 *
 * Copyright (C) 2008 Dan Williams, <dcbw@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 **************************************************************************/

#ifndef _NM_IPSEC_L2TP_H_
#define _NM_IPSEC_L2TP_H_

#include <glib-object.h>

typedef enum
{
	IPSEC_L2TP_PLUGIN_UI_ERROR_UNKNOWN = 0,
	IPSEC_L2TP_PLUGIN_UI_ERROR_INVALID_CONNECTION,
	IPSEC_L2TP_PLUGIN_UI_ERROR_INVALID_PROPERTY,
	IPSEC_L2TP_PLUGIN_UI_ERROR_MISSING_PROPERTY,
	IPSEC_L2TP_PLUGIN_UI_ERROR_FILE_NOT_READABLE,
	IPSEC_L2TP_PLUGIN_UI_ERROR_FILE_NOT_IPSEC_L2TP
} IPSecL2tpPluginUiError;

#define IPSEC_L2TP_TYPE_PLUGIN_UI_ERROR (ipsec_l2tp_plugin_ui_error_get_type ())
GType ipsec_l2tp_plugin_ui_error_get_type (void);

#define IPSEC_L2TP_PLUGIN_UI_ERROR (ipsec_l2tp_plugin_ui_error_quark ())
GQuark ipsec_l2tp_plugin_ui_error_quark (void);


#define IPSEC_L2TP_TYPE_PLUGIN_UI            (ipsec_l2tp_plugin_ui_get_type ())
#define IPSEC_L2TP_PLUGIN_UI(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI, IPSecL2tpPluginUi))
#define IPSEC_L2TP_PLUGIN_UI_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), IPSEC_L2TP_TYPE_PLUGIN_UI, IPSecL2tpPluginUiClass))
#define IPSEC_L2TP_IS_PLUGIN_UI(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI))
#define IPSEC_L2TP_IS_PLUGIN_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IPSEC_L2TP_TYPE_PLUGIN_UI))
#define IPSEC_L2TP_PLUGIN_UI_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI, IPSecL2tpPluginUiClass))

typedef struct _IPSecL2tpPluginUi IPSecL2tpPluginUi;
typedef struct _IPSecL2tpPluginUiClass IPSecL2tpPluginUiClass;

struct _IPSecL2tpPluginUi {
	GObject parent;
};

struct _IPSecL2tpPluginUiClass {
	GObjectClass parent;
};

GType ipsec_l2tp_plugin_ui_get_type (void);


#define IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET            (ipsec_l2tp_plugin_ui_widget_get_type ())
#define IPSEC_L2TP_PLUGIN_UI_WIDGET(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET, IPSecL2tpPluginUiWidget))
#define IPSEC_L2TP_PLUGIN_UI_WIDGET_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET, IPSecL2tpPluginUiWidgetClass))
#define IPSEC_L2TP_IS_PLUGIN_UI_WIDGET(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET))
#define IPSEC_L2TP_IS_PLUGIN_UI_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET))
#define IPSEC_L2TP_PLUGIN_UI_WIDGET_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), IPSEC_L2TP_TYPE_PLUGIN_UI_WIDGET, IPSecL2tpPluginUiWidgetClass))

typedef struct _IPSecL2tpPluginUiWidget IPSecL2tpPluginUiWidget;
typedef struct _IPSecL2tpPluginUiWidgetClass IPSecL2tpPluginUiWidgetClass;

struct _IPSecL2tpPluginUiWidget {
	GObject parent;
};

struct _IPSecL2tpPluginUiWidgetClass {
	GObjectClass parent;
};

GType ipsec_l2tp_plugin_ui_widget_get_type (void);

#endif	/* _NM_IPSEC_L2TP_H_ */
